#!/usr/bin/perl -w      

# fidonet mailer working over http
# ----------------------------
# by Dmitry Terentiev, dt@mskomi.ru, 2:5003/58@fidonet
# this program is freeware and provided WITHOUT ANY WARRANTY

# verison 1.0 beta
# date: 14.04.2006

use strict;
use English;
use bytes;

use CGI qw(:all);
use Fcntl qw(:flock);
use File::Copy;
use File::Path;
use File::Basename;
use MIME::Base64;
use Digest::MD5 qw(md5_hex);
use LWP::UserAgent;

my $address;
my $logfile;
my $outbound;
my $temp_outbound;
my $temp_inbound;
my $inbound;
my %uplinks;
my %links;
my $after_session;
my $http_proxy;

# 뢠 䨣

eval (read_file('config.pl') or die "can not read configuration file config.pl");

######################################################

my $outb_name;  #  襪  ⮢    bink-⡠㭤
my %flos = ();	#  ' *.?lo' -> \(ᯨ᮪ 䠩  ।)
my %temp_flos = (); #   ᠬ  ६ ⡠㭤
my %outb_files = (); #  ' 䠩  ।' -> ' *.?lo'
my %short_names = (); #  '⪮ ' ->    $outb_name

my $recv = 0;

sub write_log_a
{
  my $FILE;
  open (FILE, ">>$logfile") or die("can't write to log-file $logfile\n"), return ''; 
  flock(FILE, LOCK_EX);
  print FILE $_[0];
  flock(FILE, LOCK_UN);
  close(FILE);
}

sub get_log_hdr
{
  return scalar(localtime) . " [$PID]" . " ftnhttp: ";
}

sub write_log
{
  my $msg = get_log_hdr . "$_[0]\n";
  write_log_a($msg);
}

sub die_log
{
  my $msg = get_log_hdr . "$_[0]\n";
  warn($msg);
  write_log_a($msg);
  exit;
}

sub print_log
{
  my $msg = get_log_hdr . "$_[0]\n";
  print($msg);
  write_log_a($msg);
}

sub read_file
{
  my $FILE;
  my $tmp;
  open (FILE, $_[0]) or die_log("can't open file $_[0]\n"), return (''); 
  flock(FILE, LOCK_SH);
  while(<FILE>)
  {
    $tmp .= $_;
  }
  flock(FILE, LOCK_UN);
  close(FILE);
  return($tmp);
}

sub bin_read_file
{
  my $FILE;
  my $tmp;
  my $flen = (-s $_[0]) || -1;
  open (FILE, $_[0]) or die_log("can't open file $_[0]\n"), return (''); 
  binmode FILE;
  flock(FILE, LOCK_SH);
  sysread(FILE, $tmp, $flen);
  flock(FILE, LOCK_UN);
  close(FILE);
  return($tmp);
}

sub write_file
{
  my $FILE;
  open (FILE, ">$_[0]") or die_log("can't open file $_[0]\n"), return ''; 
  flock(FILE, LOCK_EX);
  print FILE $_[1];
  flock(FILE, LOCK_UN);
  close(FILE);
}

sub bin_write_file
{
  my $FILE;
  open (FILE, ">$_[0]") or die_log("can't open file $_[0]\n"), return ''; 
  binmode FILE;
  flock(FILE, LOCK_EX);
  syswrite(FILE, $_[1]);
  flock(FILE, LOCK_UN);
  close(FILE);
}

sub check_addr()
{
  return ($_[0] =~ /^(\d+\:)?\d+\/\d+(\.\d+)?$/);
}

sub decode_addr()
{
  if ($_[0] =~ /^(\d+\:)?(\d+)\/(\d+)(\.\d+)?$/)
  {
    my @parts = ($1 || 0, $2, $3, $4 || 0);
    $parts[0] =~ s/:$//;
    $parts[3] =~ s/^\.//;
    return @parts;
  }
}

sub check_config
{
  if (! &check_addr($address)) { die_log("error in config: our address $address are invalid!"); }
  if (! -d $outbound) { die_log("error in config: outbound $outbound not exists!"); }
  if (! -d $temp_outbound) { die_log("error in config: temp outbound $temp_outbound not exists!"); }
  if (! -d $inbound)  { die_log("error in config: inbound $inbound not exists!"); }
  if (! -d $temp_inbound)  { die_log("error in config: temp inbound $temp_inbound not exists!"); }
  if ($after_session ne '' && ! -e $after_session)  { die_log("error in config: script $after_session not exists!"); }
  foreach(keys %links)
  {
    if (! &check_addr($_)) { die_log("error in config: link address $_ are invalid!"); }
    if (! $links{$_} =~ /^\w[1,8]$/) { die_log("error in config: link password $links{$_} are invalid!");  }
  }
}

sub get_4d_name()
{
  my @parts = &decode_addr($_[0]);
  my $net = sprintf("%04x", $parts[1]);
  my $node = sprintf("%04x", $parts[2]);
  my $point = sprintf("%08x", $parts[3]);
  return($parts[3] == 0 ? $net . $node : $net . $node . ".pnt/" . $point);
}

sub check_busy()
{
  return ( -e ($outbound . $outb_name . '.bsy'));
}

sub set_busy()
{
  write_file($outbound . $outb_name . '.bsy', $PID);
}

sub unset_busy()
{
  unlink($outbound . $outb_name . '.bsy');
}

sub mk_uniq_name
{
  my $fln = $_[0];
  return $fln if ! -e $fln;
  my ($path, $base, $ext) = fileparse($fln, qr{\.\w+});
  my $cnt = 0;
  my $newpath;
  while($cnt++ < 999)
  {
    $newpath = substr("$base$path", 0, length("$base$path") - length("_$cnt")) . "_$cnt$ext";
    return $newpath if ! -e $newpath;
  }
  while(1)
  {
    $newpath = int(rand(90000000)) + 10000000;
    $newpath = "$base$newpath$ext";
    return $newpath if ! -e $newpath;
  }  
}

sub error_out
{
  my $no = $_[0];
  my $msg = $_[1];
  print "$no\n$msg\n";
  exit;
}

sub strip_lo_flags
{
  my $fln = $_[0];
  $fln =~ s/^[\^|\#]//;
  return $fln;
}

# 㤠 䠩  ⡠㭤
sub del_from_lo
{
  my $lo_name = $_[0];
  my $fln = $_[1];
  my $rflos = $_[2];
  if (! exists($$rflos{$lo_name}))
  {
    write_log("error deleting $fln from lo $lo_name: lo not exists");
    unset_busy();
    error_out(-10, "Internal error!");
  }
  my $fl_ex = 0;
  my $rfiles = $$rflos{$lo_name};
  grep {$fl_ex++ if $_ eq $fln} @$rfiles;
  if ($fl_ex <= 0)
  {
    write_log("error deleting $fln from lo $lo_name: file $fln not defined in lo");
    unset_busy();
    error_out(-11, "Internal error!");
  }
  @$rfiles = grep {! ($_ eq $fln)} @$rfiles;
  delete($outb_files{$fln});
  return if $lo_name eq '-';
  if (@$rfiles)
  {
    write_file($lo_name, join("\n", @$rfiles)) or do
    {
      write_log("error deleting $fln from lo $lo_name: can't write new lo");
      unset_busy();
      error_out(-12, "Internal error!");
    }
  } 
  else 
  {
    unlink($lo_name);
  }
}

# ७ ⮢  祩  ⡠㭤  ६ ⡠㭤
sub move_to_tmpoutb
{
  my $fln = $_[0];
  my $killsent = ($fln =~ /^\^/);
  my $truncsent = ($fln =~ /^\#/);
  my ($base, $path, $ext) = fileparse(strip_lo_flags($fln), qr{\.\w+});
  my $dflo = '';
  my $newname;
  if ($outb_files{$fln} ne '-')
  {
    $path = $temp_outbound;
    $newname = mk_uniq_name("$path$base$ext"); 
  } 
  else
  {
    $path =~ s/^$outbound/$temp_outbound/;
    $ext = '.pkt';
    $dflo = "$path$base.flo";
    $newname = mk_uniq_name("$temp_outbound$base$ext");
  }
  write_log("moving $fln to $temp_outbound");
  copy(strip_lo_flags($fln), $newname) or do
  {
    write_log("error copying $fln to $newname");
    unset_busy();
    error_out(-4, "Internal error!");
  };
  unlink(strip_lo_flags($fln)) if ($killsent or $outb_files{$fln} eq '-');
  write_file(strip_lo_flags($fln), '') if $truncsent;
  my $lo_name = $outb_files{$fln};
  del_from_lo($lo_name, $fln, \%flos);
  my $temp_lo_name = $lo_name;
  if($dflo eq '')
  {
    $temp_lo_name =~ s/^$outbound/$temp_outbound/ or do 
    {
      write_log("error finding temp-lo name for file $fln in lo $lo_name");
      unset_busy();
      error_out(-41, "Internal error!");
    }
  } else
  {
    $temp_lo_name = $dflo;   
  }
  $outb_files{$newname} = $temp_lo_name;
  my $rfiles;
  if (exists($temp_flos{$temp_lo_name}))
  {
    $rfiles = $temp_flos{$temp_lo_name};
    push(@$rfiles, $newname);
  }
  else
  {
    my @files = ($newname);
    $temp_flos{$temp_lo_name} = \@files;
    $rfiles = $temp_flos{$temp_lo_name};
  }
  ($base, $path, $ext) = fileparse($temp_lo_name, qr{\.\w+});
  eval { mkpath($path) };
  if ($@)
  {
    write_log("error creating dir for new temp-lo $temp_lo_name");
    unset_busy();
    error_out(-13, "Internal error!");
  }
  write_file($temp_lo_name, join("\n", @$rfiles)) or do
  {
    write_log("error writing new temp-lo $temp_lo_name with added $newname");
    unset_busy();
    error_out(-6, "Internal error!");
  }
}

# ࠧ ⡠㭤
sub parse_outbound
{
  my $flos = $_[0];
  my $outbound = $_[1];
  my @files = glob($$outbound . $outb_name . '.?lo');
  my $fl;
  foreach $fl (@files)
  {
    chomp($fl);
    my @fls = grep {! /^\s*$/} split(/[\n|\r\n]/, read_file($fl) || '');
    $$flos{$fl} = \@fls;
    my $fa;
    foreach $fa (@fls)
    {
      chomp($fa);
      $outb_files{$fa} = $fl;
    }
  }

  my @fls = glob($$outbound . $outb_name . '.?ut');
  return unless @fls;
  $$flos{'-'} = \@fls;
  foreach $fl (@fls)
  {
    $outb_files{$fl} = '-';
  }
}

#  ᯨ᮪ ⪨ 䠩, ⤠ 
sub extract_short_names
{
  my ($rflos, $los, $rfiles, $fln, $dir, $path, $ext);
  foreach $rflos ((\%flos, \%temp_flos))
  {
    foreach $los (sort keys(%$rflos))
    {
      $rfiles = $$rflos{$los};
      foreach $fln (sort @$rfiles)
      {
        ($path, $dir, $ext) = fileparse(strip_lo_flags($fln), qr{\.\w+});
        next if exists $short_names{"$path$ext"};
        $short_names{"$path$ext"} = $fln;
      }
    }
  }
}

##############################################

# ࠡ  

my %form = ();

sub strip_errcode
{
  my $c = $_[0];
  my $result = 0;
  my @lines = split(/[\n|\r\n]/, $$c);
  my $d = pop(@lines);
  $result = $d ne '.';
  $d = shift(@lines);
  $result = ($d =~ /^-?(\d+)$/ ? $1 : -1) if $result == 0;
  shift(@lines);
#  write_file('session.dmp', $$c);
  undef $$c;
#  write_file('session1.dmp', join("\n", @lines));
  
  return ($result, \@lines);
}

sub unbusy_die_log
{
  unset_busy();
  die_log $_[0];
}

sub do_request
{
  my $tries = 0;
  my $req = $_[0];
  my $url = $_[1];
  my $cnt;
  my $result;
  while($tries < 5)
  {
    $result = $req->post($url, \%form);
    if ($result->is_success)
    {
      $cnt = $result->content;
      return(\$cnt);
    }
    $tries++;
    print_log("http request error, retrying: " . $result->status_line);
    sleep(5);
  }
  unbusy_die_log("http request error: " . $result->status_line);
}

sub do_as_client
{
  my $addr = shift @ARGV || '';
  if ($addr eq '' or $addr =~ /^[-|\/][h|\?]$/i)
  {
    print "fido.pl - transport for fidonet mail/files over http\nworking with binkley-style outbound\n\n" .
          "client usage:\nfido.pl ADDRESS\nwhere ADDRESS - fidonet address of uplink system\n\n" .
          "server usage:\nput fido.pl into /cgi-bin/ dir on web server\n" .
          "and check that script will run with proper rights\n\nby Dmitry Terentiev (dt\@mskomi.ru, 2:5003\/58) \/ freeware";
    exit;
  }
  if (! &check_addr($addr))
  {
    die_log("error: $addr is not a fidonet address");
  }
  if (! exists $uplinks{$addr})
  {
    die_log("error: unknown uplink $addr.");
  }

  # ⨬
  
  my $req = LWP::UserAgent->new;
  $req->proxy(['http'], $http_proxy) if $http_proxy ne '';

  my ($url,$pass) = split(/\s+/, $uplinks{$addr});
  $form{'ftnpass'} = $pass;
  $form{'ftncmd'} = 'lst';
  $form{'ftnaddr'} = $address;

  $outb_name = &get_4d_name($addr);

  if (check_busy())
  {
    die_log("system $addr are busy. closing...");
  }

  set_busy();

  my ($rcode, $lines) = strip_errcode(do_request($req, $url));

  unbusy_die_log("getting listing unsuccessful: code " . $rcode) if $rcode != 0;

  print_log("connected to: $addr as $url");

  my $flnum = shift @$lines;

  print_log("remote has $flnum files for us");

  # 砥 䠩
  
  my $fl;
  
  foreach $fl (@$lines)
  {
    my ($fln, $fls, $flck) = split(/\s+/, $fl);
    print_log("receiving file $fln (size $fls bytes)");
    $form{'ftncmd'} = 'get';
    $form{'ftnfln'} = $fln;
    my ($rcode, $file) = strip_errcode(do_request($req, $url));
    unbusy_die_log("getting file unsuccessful: code " . $rcode) if $rcode != 0;
    my $flcn = decode_base64(join("\n", @$file));
    my $rlen = length($flcn);
    unbusy_die_log("file $fln size mismatch (may $fls, has $rlen)") if $rlen != $fls;
    unbusy_die_log("file $fln CRC mismatch") if md5_hex($flcn) ne $flck;
    my $flnb = mk_uniq_name("$inbound$fln");
    bin_write_file(lc($flnb), $flcn) or unbusy_die_log("can not store file $fln to inbound as $flnb");
    print_log("file $fln stored as $flnb");
    undef @$file;
    $form{'ftncmd'} = 'del';
    print_log("remote deleting file $fln");
    ($rcode, $file) = strip_errcode(do_request($req, $url));
    unbusy_die_log("deleting file unsuccessful: code " . $rcode) if $rcode != 0;
    print_log("file $fln deleted");
    undef @$file;
    $recv = 1;
  }
  undef(@$lines);
 
  # 뫠 䠩
  
  # ᪠㥬 ⡠㭤  ७ᨬ   ६ ⡠㭤
  
  parse_outbound(\%flos, \$outbound);
  parse_outbound(\%temp_flos, \$temp_outbound);
  extract_short_names();
  my ($fln, $lfln);                     	# ७ᨬ 䠩  ⡠㭤  ६ ⡠㭤
  foreach $fln (sort keys(%short_names))
  {
    my $tflos = $outb_files{$short_names{$fln}};
    next unless defined $flos{$tflos};
    if (-e strip_lo_flags($short_names{$fln}))
    {
      move_to_tmpoutb($short_names{$fln});
    }
  }
  %short_names = ();			
  extract_short_names();                        # ᮧ   ᯨ᮪ 䠩

  # 뫠 䠩
  
  foreach $fln (sort keys(%short_names))
  {
    $lfln = strip_lo_flags($short_names{$fln});
    $form{'ftnfln'} = $fln;
    $form{'ftnfct'} = bin_read_file($lfln);
    $form{'ftnfsz'} = length($form{'ftnfct'});
    $form{'ftnfck'} = md5_hex($form{'ftnfct'});
    $form{'ftncmd'} = 'put';
    my $sz = $form{'ftnfsz'};
    print_log("sending file $fln ($sz bytes) to remote");
    my $cnt = 0;
    do
    {
      ($rcode, $lines) = strip_errcode(do_request($req, $url));
      $cnt++;
      unbusy_die_log("error: can not send file $fln to remote") if $cnt > 3;
      print_log("sending file failure (code $rcode), retrying...") if $rcode != 0;
      sleep(5);
    } until($rcode == 0);
    print_log("file $fln sended to remote");
    my $tfln = shift @$lines;
    delete $form{'ftnfct'};
    delete $form{'ftnfsz'};
    delete $form{'ftnfck'};
    $form{'ftnfln'} = $tfln;
    $form{'ftncmd'} = 'pok';
    print_log("committing file $fln");
    undef @$lines;
    ($rcode, $lines) = strip_errcode(do_request($req, $url));
    unbusy_die_log("error: can not commit sended file $fln (code $rcode)") if $rcode != 0;
    if (! -e $lfln)
    {
      unbusy_die_log("error: trying delete not existent file $fln.");
    }
    del_from_lo($outb_files{$lfln}, $lfln, \%temp_flos);
    unlink($lfln);
    print_log("file $fln committed");
  }
  
  unset_busy();

  print_log("session completed");
  
  if ($recv and $after_session ne '')
  {
    print_log("files was received. exec script $after_session");
    `$after_session`;
    print_log("returned with status $?");
  }

}

##############################################

# $/ = "\012";

&check_config();

$outbound .= '/' if $outbound !~ /\/$/;
$temp_outbound .= '/' if $temp_outbound !~ /\/$/;
$inbound .= '/' if $inbound !~ /\/$/;
$temp_inbound .= '/' if $temp_inbound !~ /\/$/;

# ஢塞, 塞 ⮬  ࢥ஬

if (! exists $ENV{'GATEWAY_INTERFACE'})
{
  do_as_client();
  exit;
}

print header('application/octet-stream');

# 砥  ⮣,   뢠

my $addr = (param('ftnaddr') || ''); #  
my $pass = (param('ftnpass') || ''); #  ஫
my $cmd  = (param('ftncmd') || '');  # 訢 ⢨

my $remote_info = "$addr (from " . remote_host() . ")"; 

if (! &check_addr($addr))
{
  write_log("invalid address $addr of system. closing...");
  error_out(-3, "You are provided invalid fidonet address!\n");
}

if (! (exists $links{$addr} and (lc($links{$addr}) eq lc($pass))))
{
  write_log("unlisted system. closing...");
  error_out(-1, "You are not registered here! Please contact sysop.\n");
}

$outb_name = &get_4d_name($addr);

if (check_busy())
{
  write_log("system $addr are busy. closing...");
  error_out(-2, "Your address $addr are busy now. Try later\n");
}

set_busy();

# ࠧࠥ ⡠㭤   

my @out = ();

if($cmd eq 'lst')				# 뤠 ᯨ᮪ 䠩 
{
  parse_outbound(\%flos, \$outbound);
  parse_outbound(\%temp_flos, \$temp_outbound);
  extract_short_names();
  my ($fln, $lfln);                     	# ७ᨬ 䠩  ⡠㭤  ६ ⡠㭤
  write_log("remote $remote_info requesting filelist");
  foreach $fln (sort keys(%short_names))
  {
    my $tflos = $outb_files{$short_names{$fln}};
    next unless defined $flos{$tflos};
    if (-e strip_lo_flags($short_names{$fln}))
    {
      move_to_tmpoutb($short_names{$fln});
    }
  }
  %short_names = ();			
  extract_short_names();                        # ᮧ   ᯨ᮪ 䠩
  foreach $fln (sort keys(%short_names))
  {
    $lfln = strip_lo_flags($short_names{$fln});
    next if ! -e $lfln;
    push(@out, "$fln " . (-s $lfln) . ' ' . md5_hex(bin_read_file($lfln)));
  }
  print "0\nOK\n";
  print scalar(@out) . "\n";
  print join("\n", @out);
}
elsif ($cmd eq 'get')				# 뤠 䠩 
{
  my ($fln, $lfln);
  parse_outbound(\%temp_flos, \$temp_outbound);
  extract_short_names();
  $fln = (param('ftnfln') || '');
  write_log("remote $remote_info downloading file $fln / size:" . (-s ($short_names{$fln} || '') || '?'));
  $lfln = $short_names{$fln};
  if (! defined $lfln or ! -e $lfln)
  {
    write_log("error: remote requested invalid file $fln. closing...");
    unset_busy();
    error_out(-2, "Error: you requested invalid file $fln\n");
  }
  print "0\nOK\n";
  print encode_base64(bin_read_file(strip_lo_flags($lfln)));
}
elsif ($cmd eq 'del')				# 㤠塞 䠩,  ᫠
{
  parse_outbound(\%temp_flos, \$temp_outbound);
  extract_short_names();
  my ($fln, $lfln);
  $fln = (param('ftnfln') || '');
  write_log("remote $remote_info deleting file $fln");
  $lfln = $short_names{$fln};
  if (! defined $lfln or ! -e $lfln)
  {
    write_log("error: remote deleting invalid file $fln. closing.");
    unset_busy();
    error_out(-2, "Error: you deleting invalid file $fln\n");
  }
  del_from_lo($outb_files{$lfln}, $lfln, \%temp_flos);
  unlink($lfln);
  print "0\nOK";
}
elsif ($cmd eq 'put')				# ਭ 䠩  㤠 ஭
{
  my $fln = param('ftnfln') || '';
  my $flsz = param('ftnfsz') || -1;
  my $flcrc = param('ftnfck') || '';
  my $fl = param('ftnfct') || '';
  write_log("remote $remote_info uploading file $fln / size: $flsz");
  if (($flsz < 0) or ($flcrc eq ''))
  {
    write_log("error: remote trying upload file with invalid parameters.");
    unset_busy();
    error_out(-2, "Error: invalid parameters for uploading\n");
  }
  if (length($fl) != $flsz or md5_hex($fl) ne $flcrc)
  {
    write_log("error: CRC or size of uploaded file $fln mismatch.");
    unset_busy();
    error_out(-2, "Error: CRC or size of uploaded file $fln mismatch\n");
  };
  my $tfln = mk_uniq_name($temp_inbound . lc($fln));
  bin_write_file($tfln, $fl) or do
  {
    write_log("error: can't write $tfln to temp-inbound.");
    unset_busy();
    error_out(-2, "Error: can't store uploaded file\n");
  };
  write_log("uploaded file $fln stored as $tfln");
  print "0\nOK\n";
  print $tfln;
}
elsif ($cmd eq 'pok')				# e७ᨬ ਭ 䠩  㭤
{
  my $fln = param('ftnfln') || '';
  write_log("remote $remote_info committing uploaded file $fln");
  if ($fln !~ /^$temp_inbound\w+(\.\w+)?$/)
  {
    write_log("error: trying moving invalid file $fln.");
    unset_busy();
    error_out(-2, "Error: invalid file name\n");
  }
  if (! -e $fln)
  {
    write_log("error: file $fln not  exists in temp inbound.");
    unset_busy();
    error_out(-2, "Error: non-existent file\n");
  }
  my $tfln = $fln;
  $tfln =~ s/^$temp_inbound/$inbound/;
  $tfln = mk_uniq_name($tfln);
  write_log("moving $fln to $tfln");
  copy($fln, $tfln) or do
  {
    write_log("error: can't move $fln to inbound (to $tfln).");
    unset_busy();
    error_out(-2, "Error: can't move uploaded file\n");
  };
  unlink($fln);
  $recv = 1;
  print "0\nOK\n";
}
else 
{
  write_log("error: remote passed invalid command. closing...");
  unset_busy();
  error_out(-2, "Error: you are sended invalid command\n");
}
print "\n.\n";

if ($recv and $after_session ne '')
{
  write_log("files was received. exec script $after_session");
  `$after_session`;
  write_log("returned with status $?");
}

unset_busy();

1;